﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using SharePointIntegrationWeb.Model;

namespace SharePointIntegrationWeb
{
    public class DAO
    {
        private static string sqlString = @"Data Source=qjauqbgpqz.database.windows.net;Initial Catalog=membersystem;Integrated Security=False;User ID=membersystem;Password=U'TP9UDkQ+eN(q$y;Connect Timeout=60;Encrypt=False;TrustServerCertificate=False";
        private readonly SqlConnection _sqlConnection;
        private static DAO _instance;

        private DAO()
        {
            _sqlConnection = new SqlConnection(sqlString);
        }
        public static DAO Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new DAO();
                }
                return _instance;
            }
        }

        /// <summary>
        /// Saves the member in database.
        /// </summary>
        /// <param name="member">Member object</param>
        /// <returns>memberId</returns>
        public int AddMember(Member member)
        {
            try
            {
                String SQLQuery;
                if (member.Position == null)
                {
                    SQLQuery = "INSERT INTO Member VALUES(@Name, @Email, @Birthday, @Phone, @Address, @City, @ZipCode, @MemberType, @ApprovedBy, @Created, null);SELECT CAST(scope_identity() AS int)";
                }
                else
                {
                    SQLQuery = "INSERT INTO Member VALUES(@Name, @Email, @Birthday, @Phone, @Address, @City, @ZipCode, @MemberType, @ApprovedBy, @Created, @Role);SELECT CAST(scope_identity() AS int)";
                }
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Name", member.Name);
                command.Parameters.Add(param);
                param = new SqlParameter("@Email", member.Email);
                command.Parameters.Add(param);
                param = new SqlParameter("@Birthday", member.Birthday);
                command.Parameters.Add(param);
                param = new SqlParameter("@Phone", member.Phone);
                command.Parameters.Add(param);
                param = new SqlParameter("@Address", member.Address);
                command.Parameters.Add(param);
                param = new SqlParameter("@City", member.City);
                command.Parameters.Add(param);
                param = new SqlParameter("@ZipCode", member.ZipCode);
                command.Parameters.Add(param);
                param = new SqlParameter("@MemberType", member.MemberType);
                command.Parameters.Add(param);
                param = new SqlParameter("@ApprovedBy", member.ApprovedBy);
                command.Parameters.Add(param);
                param = new SqlParameter("@Created", DateTime.Now);
                command.Parameters.Add(param);
                if (member.Position != null)
                {
                    param = new SqlParameter("@Role", member.Position);
                    command.Parameters.Add(param);
                }
                _sqlConnection.Open();
                Int32 memberId = (Int32)(command.ExecuteScalar());
                return memberId;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Checks if the E-mail is used in the system
        /// </summary>
        /// <param name="email">Email that has to be check</param>
        /// <returns>True if used</returns>
        public bool IsEmailUsed(string email)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT COUNT(Email) FROM Member WHERE Email = @email";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@email", email);
                command.Parameters.Add(param);
                Int32 length = (Int32)command.ExecuteScalar();
                if (length > 0)
                {
                    return true;
                }
                return false;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Add subscription for a member
        /// </summary>
        /// <param name="memberId">Member id</param>
        /// <returns>True if added</returns>
        public bool AddSubscibtion(int memberId)
        {
            try
            {
                String SQLQuery = "INSERT INTO Subscibtion VALUES(@MemberId, @Date)";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@MemberId", memberId);
                command.Parameters.Add(param);
                param = new SqlParameter("@Date", DateTime.Now.AddYears(1));
                command.Parameters.Add(param);
                _sqlConnection.Open();
                command.ExecuteNonQuery();
                return true;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the type of membership
        /// </summary>
        /// <param name="email">Members E-mail</param>
        /// <returns>Member type</returns>
        public string GetMemberType(string email)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT MemberType FROM Member WHERE Email = @email";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@email", email);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    return dr["MemberType"].ToString();
                }
                return "User not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets a member object
        /// </summary>
        /// <param name="email">Member's email</param>
        /// <returns>Member object</returns>
        public Member GetMember(string email)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT * FROM Member WHERE Email = @email";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@email", email);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    int id = int.Parse(dr["Id"].ToString());
                    string name = dr["Name"].ToString();
                    DateTime birthday = DateTime.Parse(dr["Birthday"].ToString());
                    string phone = dr["Phone"].ToString();
                    string address = dr["Address"].ToString();
                    string city = dr["City"].ToString();
                    string zipCode = dr["ZipCode"].ToString();
                    string memberType = dr["MemberType"].ToString();
                    string approvedBy = dr["ApprovedBy"].ToString();
                    string role = dr["Role"].ToString();

                    Member member = new Member(id, name, email, birthday, phone, address, city, zipCode, memberType, approvedBy);
                    member.Position = role;

                    return member;
                }
                return null;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets a member object
        /// </summary>
        /// <param name="memberId">Member's id</param>
        /// <returns>Member object</returns>
        public Member GetMember(int memberId)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT * FROM Member WHERE Id = @Id";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Id", memberId);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    int id = int.Parse(dr["Id"].ToString());
                    string name = dr["Name"].ToString();
                    string email = dr["Email"].ToString();
                    DateTime birthday = DateTime.Parse(dr["Birthday"].ToString());
                    string phone = dr["Phone"].ToString();
                    string address = dr["Address"].ToString();
                    string city = dr["City"].ToString();
                    string zipCode = dr["ZipCode"].ToString();
                    string memberType = dr["MemberType"].ToString();
                    string approvedBy = dr["ApprovedBy"].ToString();
                    string role = dr["Role"].ToString();

                    Member member = new Member(id, name, email, birthday, phone, address, city, zipCode, memberType, approvedBy);
                    member.Position = role;

                    return member;
                }
                return null;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Edits the info for a member
        /// </summary>
        /// <param name="id">Member's id</param>
        /// <param name="member">Member object</param>
        /// <returns>"accepted" if a member have been edited</returns>
        public string EditMember(string id, Member member)
        {
            String city = GetCity(Int32.Parse(member.ZipCode));
            try
            {
                String SQLQuery = "UPDATE Member SET Name = @Name, Email = @Email, Birthday = @Birthday, Phone = @Phone, Address = @Address, City = @City, ZipCode = @ZipCode, MemberType = @MemberType, Role = @Role WHERE Id = @id";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Name", member.Name);
                command.Parameters.Add(param);
                param = new SqlParameter("@Email", member.Email);
                command.Parameters.Add(param);
                param = new SqlParameter("@Birthday", member.Birthday);
                command.Parameters.Add(param);
                param = new SqlParameter("@Phone", member.Phone);
                command.Parameters.Add(param);
                param = new SqlParameter("@Address", member.Address);
                command.Parameters.Add(param);
                param = new SqlParameter("@City", city);
                command.Parameters.Add(param);
                param = new SqlParameter("@ZipCode", member.ZipCode);
                command.Parameters.Add(param);
                param = new SqlParameter("@MemberType", member.MemberType);
                command.Parameters.Add(param);
                param = new SqlParameter("@id", id);
                command.Parameters.Add(param);
                param = new SqlParameter("@Role", member.Position);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                command.ExecuteNonQuery();
                return "accepted";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Changes the member's type to "Arkiveret"
        /// </summary>
        /// <param name="email">Member's email</param>
        /// <returns>"accepted" if a member has been edited. "user not found" if the member not found</returns>
        public string ArchiveUser(String email)
        {
            try
            {
                String SQLQuery;
                string memberType = GetMemberType(email);
                if (memberType != "Arkiveret")
                {
                    SQLQuery = "UPDATE Member SET MemberType = 'Arkiveret' WHERE Email = @Email";
                }
                else
                {
                    SQLQuery = "UPDATE Member SET MemberType = 'Medlem' WHERE Email = @Email";
                }
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Email", email);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return "accepted";
                }
                return "user not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Search for members using their name.
        /// Can also search for member if you don't type all of member's name
        /// </summary>
        /// <param name="searchName">Member's name</param>
        /// <returns>List of members</returns>
        public List<Member> SearchMember(string searchName)
        {
            var foundMembers = new List<Member>();
            try
            {
                String SQLQuery = "SELECT * FROM Member WHERE Name like '%' + @Name + '%'";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Name", searchName);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    string name = dr["Name"].ToString();
                    DateTime birthday = DateTime.Parse(dr["Birthday"].ToString());
                    string email = dr["Email"].ToString();
                    string phone = dr["Phone"].ToString();
                    string address = dr["Address"].ToString();
                    string city = dr["City"].ToString();
                    string zipCode = dr["ZipCode"].ToString();
                    string memberType = dr["MemberType"].ToString();
                    string approvedBy = dr["ApprovedBy"].ToString();
                    string role = dr["Role"].ToString();

                    Member member = new Member(name, email, birthday, phone, address, city, zipCode, memberType, approvedBy);
                    member.Position = role;

                    foundMembers.Add(member);
                }
                return foundMembers;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets list of non activated members
        /// </summary>
        /// <returns>List of non activated members</returns>
        public List<Member> GetNonActivatedMembers()
        {
            List<Member> members = new List<Member>();
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT * FROM Member WHERE MemberType = 'Deaktiveret'";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    int id = int.Parse(dr["Id"].ToString());
                    string name = dr["Name"].ToString();
                    string email = dr["Email"].ToString();
                    DateTime birthday = DateTime.Parse(dr["Birthday"].ToString());
                    string phone = dr["Phone"].ToString();
                    string address = dr["Address"].ToString();
                    string city = dr["City"].ToString();
                    string zipCode = dr["ZipCode"].ToString();
                    string memberType = dr["MemberType"].ToString();

                    members.Add(new Member(id, name, email, birthday, phone, address, city, zipCode, memberType, "")); // ApprovedBy is empty
                }

                return members;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Changes member's type to "Medlem" and the user who approved the member will be put in member's approvedBy.
        /// </summary>
        /// <param name="userId">Member id</param>
        /// <param name="approvedByEmail">The admin who accepted the member</param>
        /// <returns>"accepted" if accepted. "user not found" if member not found</returns>
        public string AcceptUser(int userId, string approvedByEmail)
        {
            try
            {
                String SQLQuery = "UPDATE Member SET MemberType = 'Medlem', approvedBy = @Email WHERE Id = " + userId;
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Email", approvedByEmail);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return "accepted";
                }
                return "user not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Deletes the member who have signed up
        /// </summary>
        /// <param name="memberId">Member id</param>
        /// <returns>"accepted" if accepted. "user not found" if member not found</returns>
        public string DeclineUser(int memberId)
        {
            try
            {
                String SQLQuery = "DELETE FROM Member WHERE Id = " + memberId;
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return "accepted";
                }
                return "user not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Counts deactivated members in the database.
        /// </summary>
        /// <returns>Length of deactivated members</returns>
        public int DeactivatedMembers()
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT Count(*) FROM Member WHERE MemberType = 'Deaktiveret'";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                Int32 length = (Int32)command.ExecuteScalar();
                return length;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the city by zip code
        /// </summary>
        /// <param name="zipCode">Zip code</param>
        /// <returns>City name</returns>
        public string GetCity(int zipCode)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT City FROM City WHERE ZipCode = @zipCode";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@zipCode", zipCode);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    return dr["City"].ToString();
                }
                return "City not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Adds invoice for a member
        /// </summary>
        /// <param name="subcriptionId">Member's subcription id</param>
        /// <param name="iPrice">Price</param>
        /// <returns>Invoice id</returns>
        public string CreateInvoice(string subcriptionId, string iPrice)
        {

            try
            {
                String SQLQuery = "INSERT INTO Invoice VALUES(@SubcriptionId, @Paid, @Price);SELECT CAST(scope_identity() AS int);";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@SubcriptionId", subcriptionId);
                command.Parameters.Add(param);
                param = new SqlParameter("@Paid", "N");
                command.Parameters.Add(param);
                string newPrice = iPrice.Replace(',', '.');
                param = new SqlParameter("@Price", double.Parse(newPrice));
                command.Parameters.Add(param);
                _sqlConnection.Open();
                Int32 invoiceNumber = (Int32)(command.ExecuteScalar());
                return invoiceNumber.ToString();
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the price for member type
        /// </summary>
        /// <param name="memberType">Member type</param>
        /// <returns>Price</returns>
        public string GetPrice(string memberType)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT Price FROM Type WHERE MemberType = @memberType";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@memberType", memberType);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    return dr["Price"].ToString();
                }
                return "Type not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Updates a invoice to paid
        /// </summary>
        /// <param name="invoiceId">Invoice id</param>
        /// <returns></returns>
        public bool PayInvoice(string invoiceId)
        {
            try
            {
                String SQLQuery = "UPDATE Invoice SET Paid = @Paid WHERE Id = @Id";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Paid", 'Y');
                command.Parameters.Add(param);
                param = new SqlParameter("@Id", invoiceId);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return true;
                }
                return false;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Adds a year to the subscription.
        /// Called after when a member has paid.
        /// </summary>
        /// <param name="subscibtionId">Member's subscription id</param>
        /// <returns>true if added</returns>
        public bool AddYearSubscribtion(string subscibtionId)
        {
            DateTime date = DateTime.Now;
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT Date FROM Subscibtion WHERE Id = @subscibtionId";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@subscibtionId", subscibtionId);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();

                while (dr.Read())
                {
                    date = Convert.ToDateTime(dr["Date"].ToString()).AddYears(1);
                }
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }

            try
            {
                _sqlConnection.Open();
                string SQLQuery = "UPDATE Subscibtion SET Date = @Date WHERE Id = @Id";
                var command = new SqlCommand(SQLQuery, _sqlConnection);
                var param = new SqlParameter("@Id", subscibtionId);
                command.Parameters.Add(param);
                param = new SqlParameter("@Date", date);
                command.Parameters.Add(param);

                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return true;
                }
                return false;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }

        }

        /// <summary>
        /// Deletes a invoice by invoice id
        /// </summary>
        /// <param name="invId">Invoice id</param>
        /// <returns>"accepted" if accepted. "invoice not found" if invoice not found</returns>
        public string DeleteInvoice(string invId)
        {
            try
            {
                String SQLQuery = "DELETE FROM Invoice WHERE Id = " + invId;
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                if (affectedRows > 0)
                {
                    return "accepted";
                }
                return "invoice not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the subcription id by member id
        /// </summary>
        /// <param name="memberId">Member's id</param>
        /// <returns>Subscription id</returns>
        public string GetSubscribtion(string memberId)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT Id FROM Subscibtion WHERE MemberId = @memberId";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@MemberId", memberId);
                command.Parameters.Add(param);
                SqlDataReader dr = command.ExecuteReader();

                while (dr.Read())
                {
                    return dr["Id"].ToString();
                }
                return "Sub not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the member id by subscription id
        /// </summary>
        /// <param name="subNr">Subscription id</param>
        /// <returns>Member id if found. "Sub not found" if the subscription not found</returns>
        public string GetMemberIdBySubNr(string subNr)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT MemberId FROM Subscibtion WHERE Id = '" + subNr + "'";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlDataReader dr = command.ExecuteReader();

                while (dr.Read())
                {
                    return dr["MemberId"].ToString();
                }
                return "Sub not found";
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Edits the invoices info.
        /// Company's info will only be altered.
        /// </summary>
        /// <param name="bankName">Bank name</param>
        /// <param name="regNr">Reg. nr</param>
        /// <param name="kontoNr">Konto nr.</param>
        /// <param name="address">Address</param>
        /// <param name="zipCode">Zip code</param>
        /// <param name="city">City name</param>
        /// <param name="phone">Phone nr.</param>
        /// <param name="message">Message at the button of the invoice</param>
        /// <returns>true if edited</returns>
        public bool EditInvoiceInfo(string bankName, string regNr, string kontoNr, string address, string zipCode, string city,
            string phone, string message)
        {
            try
            {
                String SQLQuery = "UPDATE InvoiceInfo SET RegNr = @regNr, KontoNr = @kontoNr, Address = @address, ZipCode = @zipCode, City = @city, Phone = @phone, BankName = @bankName, Message = @message WHERE Id = 0";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@regNr", regNr);
                command.Parameters.Add(param);
                param = new SqlParameter("@kontoNr", kontoNr);
                command.Parameters.Add(param);
                param = new SqlParameter("@address", address);
                command.Parameters.Add(param);
                param = new SqlParameter("@zipCode", zipCode);
                command.Parameters.Add(param);
                param = new SqlParameter("@city", city);
                command.Parameters.Add(param);
                param = new SqlParameter("@phone", phone);
                command.Parameters.Add(param);
                param = new SqlParameter("@bankName", bankName);
                command.Parameters.Add(param);
                param = new SqlParameter("@message", message);
                command.Parameters.Add(param);

                _sqlConnection.Open();
                int affectedRows = command.ExecuteNonQuery();
                return affectedRows > 0;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");

                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Gets the info for invoices, that only contains info about the company.
        /// </summary>
        /// <returns>Dictionary of company's info</returns>
        public Dictionary<string, string> GetInvoiceInfo()
        {
            Dictionary<string, string> invoiceInfo = new Dictionary<string, string>(1);
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT * FROM InvoiceInfo";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlDataReader dr = command.ExecuteReader();

                while (dr.Read())
                {
                    invoiceInfo.Add("RegNr", dr["RegNr"].ToString());
                    invoiceInfo.Add("KontoNr", dr["KontoNr"].ToString());
                    invoiceInfo.Add("Address", dr["Address"].ToString());
                    invoiceInfo.Add("ZipCode", dr["ZipCode"].ToString());
                    invoiceInfo.Add("City", dr["City"].ToString());
                    invoiceInfo.Add("Phone", dr["Phone"].ToString());
                    invoiceInfo.Add("BankName", dr["BankName"].ToString());
                    invoiceInfo.Add("Message", dr["Message"].ToString());
                }
                return invoiceInfo;
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        /// <summary>
        /// Deletes all verification codes
        /// </summary>
        public void DeleteAllVerificationCodes()
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "DELETE FROM VerificationCode";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                command.ExecuteReader();
            }
            catch (SqlException sqlEx)
            {
                Membersystem.ExceptionUtility.LogException(sqlEx, "Sql");
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }
    }
}