﻿using System;
using System.Web.UI.HtmlControls;
using SharePointIntegrationWeb.Controller;

namespace SharePointIntegrationWeb.Pages
{
    public partial class ArchiveConfirm : System.Web.UI.Page
    {
        MemberController _memberController = new MemberController();
        /// <summary>
        /// Checks if the membertype is "Bestyrelse", else redirect him back to startpage.
        /// Requests the query string from the email, which is sent when clicking on 'Arkivér'.
        /// Fires the method that archives a user in the controller.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if ((string)Session["MemberType"] == "Bestyrelse")
            {
                string email = Request.QueryString["email"];
                string message = _memberController.ArchiveUser(email);
                message += ". Du vil blive sendt tilbage om 3 sekunder.";
                Response.Write(message);
                Redirect(3, "SearchMember.aspx");
            }
            else
            {
                Response.Redirect((string)Session["StartPage"]);
            }
        }
        /// <summary>
        /// Refreshes the page which redirects him back to the page for member search.
        /// </summary>
        /// <param name="seconds">Seconds passing before it refreshes</param>
        /// <param name="url">Url which the method sends the user to</param>
        private void Redirect(int seconds, string url)
        {
            HtmlMeta meta = new HtmlMeta();
            meta.HttpEquiv = "Refresh";
            meta.Content = seconds + ";" + url;
            Page.Controls.Add(meta);
        }
    }
}