﻿using System;
using System.Collections.Generic;
using SharePointIntegrationWeb.Controller;

namespace SharePointIntegrationWeb.Pages
{
    public partial class EditInvoice : System.Web.UI.Page
    {
        MemberController _memberController = new MemberController();
        /// <summary>
        /// Checks if the membertype is "Bestyrelse", else redirect him back to startpage.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_PreRender(object sender, EventArgs e)
        {
            string memberType = (string)Session["MemberType"];
            if (memberType != "Bestyrelse")
            {
                Response.Redirect((string)Session["StartPage"]);
            }
        }
        /// <summary>
        /// On page load it will get all the invoice info from the database and insert it into the input fields.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Dictionary<string, string> invoiceInfoDictionary = _memberController.GetInvoiceInfo();

                BankName.Text = invoiceInfoDictionary["BankName"];
                RegNr.Text = invoiceInfoDictionary["RegNr"];
                KontoNr.Text = invoiceInfoDictionary["KontoNr"];
                Phone.Text = invoiceInfoDictionary["Phone"];
                Address.Text = invoiceInfoDictionary["Address"];
                ZipCode.Text = invoiceInfoDictionary["ZipCode"];
                City.Text = invoiceInfoDictionary["City"];
                Message.InnerText = invoiceInfoDictionary["Message"];
            }
        }

        protected void Cancel_Click(object sender, EventArgs e)
        {
            Response.Redirect((string)Session["StartPage"]);
        }
        /// <summary>
        /// Sends all the changes back to the database, when the administrator clicks "Submit".
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Submit_Click(object sender, EventArgs e)
        {
            string bankName = BankName.Text;
            string regNr = RegNr.Text;
            string kontoNr = KontoNr.Text;
            string phone = Phone.Text;
            string address = Address.Text;
            string zipCode = ZipCode.Text;
            string city = City.Text;
            string message = Message.InnerText;
            bool updated = _memberController.EditInvoiceInfo(bankName, regNr, kontoNr, phone, address, zipCode, city, message);
            if (updated)
            {
                statusLabel.Visible = true;
                statusLabel.Text = "Opdateret";
            }
            else
            {
                statusLabel.Visible = true;
                statusLabel.Text = "Fejl";
            }
        }
    }
}