﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="EditProfile.aspx.cs" Inherits="SharePointIntegrationWeb.Pages.EditProfile" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    <link href="../Content/Site.css" type="text/css" rel="stylesheet" />
    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap.min.css" />

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap-theme.min.css" />

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>

</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
        <div id="fields">
            <asp:UpdatePanel ID="UpdatePanel1" runat="server">
                <ContentTemplate>
                    <asp:Label runat="server" Visible="False" ID="statusLabel"></asp:Label>
                    <br />

                    <asp:TextBox ID="ID" runat="server" Visible="False" class="form-control" />
                    <br />
                    <div class="editLabelDiv">Navn:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="Name" runat="server" placeholder="Navn og efternavn" class="form-control" onchange="CheckInputs()" oninput="CheckInputs()" />
                    </div>
                    <br />
                    <div class="editLabelDiv">E-mail:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="email" ID="Email" runat="server" placeholder="email@email.dk" class="form-control" ReadOnly="True" onchange="CheckInputs()" oninput="CheckInputs()" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Fødselsdag:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="Birthday" runat="server" placeholder="dd/mm/yyyy" class="form-control" ReadOnly="True" onchange="CheckInputs()" oninput="CheckInputs()" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Telefon:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="Phone" runat="server" placeholder="12345678" class="form-control" onchange="CheckInputs()" oninput="CheckInputs()" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Adresse:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="Address" runat="server" placeholder="Din adresse" class="form-control" onchange="CheckInputs()" oninput="CheckInputs()" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Postnummer:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="ZipCode" MaxLength="4" oninput="GetCity()" runat="server" placeholder="Dit postnummer" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">By:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="City" runat="server" placeholder="Din by" class="form-control" onclick="CheckInputs()" oninput="CheckInputs()" ReadOnly="True" />
                    </div>
                    <br />

                    <div id="Member" runat="server" class="editLabelDiv">
                        <asp:Label ID="MemberTypeText" Visible="False" runat="server" Text="Medlemstype:"></asp:Label>
                    </div>
                    <div class="editInputDiv">
                        <asp:DropDownList ID="MemberType" AutoPostBack="true" OnSelectedIndexChanged="MemberType_OnSelectedIndexChanged" Visible="False" class="form-control" Enabled="False" runat="server">
                            <asp:ListItem Text="Bestyrelse" Value="0" />
                            <asp:ListItem Text="Medlem" Value="1" />
                            <asp:ListItem Text="Arkiveret" Value="2" />
                            <asp:ListItem Text="Deaktiveret" Value="3" />
                        </asp:DropDownList>
                    </div>
                    <br />
                    <div class="editLabelDiv" id="PositionText" runat="server" visible="false">Rolle:</div>
                    <div class="editInputDiv">
                        <asp:TextBox type="text" ID="Position" runat="server" Visible="false" placeholder="Indtast medlemmets rolle i organisationen" class="form-control" onchange="CheckInputs()" oninput="CheckInputs()" ReadOnly="false" />
                    </div>
                    <br />
                    <asp:Button ID="Submit" runat="server" Text="Gem" OnClick="Submit_Click" class="btn btn-default" AutoPostBack="true" />
                    <asp:Button ID="Cancel" runat="server" Text="Tilbage" class="btn btn-default" OnClick="Cancel_Click" />
                    <br />
                    <asp:Label ID="errorlabel" runat="server" Visible="False"></asp:Label>
                </ContentTemplate>
            </asp:UpdatePanel>
        </div>
    </form>
</body>
</html>


<script type="text/javascript">

    if ($("#ZipCode").val().length === 4) {
        GetCity();
    }

    function GetCity() {
        var zipCode = $("#ZipCode").val();
        if (isNaN(zipCode)) {
            $("#Submit").prop('disabled', true);
            alert("Postnummer må kun indeholde nummer");
        }
        else if (zipCode.length < 4) {
            $("#City").val("");
        }
        else if (zipCode.length === 4) {
            $.ajax({
                type: "POST", //HTTP method
                url: "EditProfile.aspx/ZipCode_OnTextChanged", //page/method name
                data: "{'zipCode':'" + zipCode + "'}", //json to represent argument
                contentType: "application/json; charset=utf-8",
                success: function (data, textStatus, jqXHR) { //handle the callback to handle response
                    if (data.d === "City not found") {
                        $("#City").val("By ikke fundet");
                        $("#Submit").prop('disabled', true);
                    } else {
                        $("#City").val(data.d);
                        CheckInputs();
                    }
                }
            });
        }
    }

    function CheckInputs() {
        var name = $("#Name").val();
        var email = $("#Email").val();
        var birthday = $("#Birthday").val();
        var phone = $("#Phone").val();
        var address = $("#Address").val();
        var zipCode = $("#ZipCode").val();
        var city = $("#City").val();

        if (name.length === 0 || email.length === 0 || birthday.length === 0 || phone.length === 0 || address.length === 0 || zipCode.length === 0 || zipCode === "By ikke fundet" || city.length === 0) {
            $("#Submit").prop('disabled', true);
        } else {
            $("#Submit").prop('disabled', false);
        }
    }

</script>
