﻿using System;
using SharePointIntegrationWeb.Controller;

namespace SharePointIntegrationWeb.Pages
{
    public partial class Options : System.Web.UI.Page
    {
        static readonly MemberController _memberController = new MemberController();
        /// <summary>
        /// Checks if the membertype is "Bestyrelse", else redirect him back to startpage.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_PreRender(object sender, EventArgs e)
        {
            string memberType = (string)Session["MemberType"];
            if (memberType != "Bestyrelse")
            {
                Response.Redirect((string)Session["StartPage"]);
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        protected void Cancel_Click(object sender, EventArgs e)
        {
            Response.Redirect((string)Session["StartPage"]);
        }
        /// <summary>
        /// This method is fired when he clicks to delete redundant data in the database.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void OnClick(object sender, EventArgs e)
        {
            try
            {
                _memberController.DeleteAllVerificationCodes();
                statusLabel.Visible = true;
                statusLabel.Text = "Overflødig data blev slettet";
            }
            catch (Exception ex)
            {
                statusLabel.Visible = true;
                statusLabel.Text = ex.Message;
            }
            
        }
    }
}