﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="EditInvoice.aspx.cs" Inherits="SharePointIntegrationWeb.Pages.EditInvoice" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    <link href="../Content/Site.css" type="text/css" rel="stylesheet" />
    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap.min.css" />

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap-theme.min.css" />

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
        <div id="fields">
            <asp:UpdatePanel ID="UpdatePanel1" runat="server">
                <ContentTemplate>
                    <asp:Label runat="server" Visible="False" ID="statusLabel"></asp:Label>
                    <span id="helpBlock" class="help-block">Her kan du ændre i de oplysninger der bliver vist på fakturaen.</span>
                    <br />
                    <div class="editLabelDiv">Bank navn:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="BankName" runat="server" placeholder="Navnet på banken" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Reg. Nr:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="RegNr" runat="server" placeholder="Registrerings nummer" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Konto Nr:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="KontoNr" runat="server" placeholder="Konto nummer" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Telefon:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="Phone" runat="server" placeholder="K19s Venner's telefon nummer" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Addresse:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="Address" runat="server" placeholder="K19s Venner's addresse" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Postnummer:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="ZipCode" runat="server" oninput="GetCity()" placeholder="Postnummer" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">By:</div>
                    <div class="editInputDiv">
                        <asp:TextBox ID="City" runat="server" placeholder="By" class="form-control" />
                    </div>
                    <br />
                    <div class="editLabelDiv">Besked:</div>
                    <div class="editInputDiv">
                        <textarea id="Message" class="form-control" runat="server" cols="20" rows="10" placeholder="Indtast besked her"></textarea>
                    </div>
                    <br />
                    <asp:Button ID="Submit" runat="server" Text="Gem" OnClick="Submit_Click" class="btn btn-default" />
                    <asp:Button ID="Cancel" runat="server" Text="Tilbage" class="btn btn-default" OnClick="Cancel_Click" />
                    <br />
                    <br />

                    <asp:Label ID="errorlabel" runat="server" Visible="False"></asp:Label>
                </ContentTemplate>
            </asp:UpdatePanel>
        </div>
    </form>
</body>
</html>

<script type="text/javascript">
    if ($("#ZipCode").val().length === 4) {
        GetCity();
    }

    function GetCity() {
        var zipCode = $("#ZipCode").val();
        if (isNaN(zipCode)) {
            $("#Submit").prop('disabled', true);
            alert("Postnummer må kun indeholde nummer");
        }
        else if (zipCode.length < 4) {
            $("#City").val("");
        }
        else if (zipCode.length === 4) {
            $.ajax({
                type: "POST", //HTTP method
                url: "EditProfile.aspx/ZipCode_OnTextChanged", //page/method name
                data: "{'zipCode':'" + zipCode + "'}", //json to represent argument
                contentType: "application/json; charset=utf-8",
                success: function (data, textStatus, jqXHR) { //handle the callback to handle response
                    if (data.d === "City not found") {
                        $("#City").val("By ikke fundet");
                        $("#Submit").prop('disabled', true);
                    } else {
                        $("#City").val(data.d);
                    }
                }
            });
        }
    }
</script>
