﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Web;

namespace SignUp
{
    public class DAO
    {
        private static string sqlString = @"Data Source=qjauqbgpqz.database.windows.net;Initial Catalog=membersystem;Integrated Security=False;User ID=membersystem;Password=U'TP9UDkQ+eN(q$y;Connect Timeout=60;Encrypt=False;TrustServerCertificate=False";
        private readonly SqlConnection _sqlConnection;
        private static DAO _instance;

        private DAO()
        {
            _sqlConnection = new SqlConnection(sqlString);
        }
        public static DAO Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new DAO();
                }
                return _instance;
            }
        }

        public bool SignUp(string iName, string iEmail, string iBirthday, string iPhone, string iAddress, string iCity, string iZipCode)
        {
            try
            {
                String SQLQuery = "INSERT INTO Member VALUES(@Name, @Email, @Birthday, @Phone, @Address, @City, @ZipCode, @MemberType, null, null, null);SELECT CAST(scope_identity() AS int)";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Name", iName);
                command.Parameters.Add(param);
                param = new SqlParameter("@Email", iEmail);
                command.Parameters.Add(param);
                param = new SqlParameter("@Birthday", iBirthday);
                command.Parameters.Add(param);
                param = new SqlParameter("@Phone", iPhone);
                command.Parameters.Add(param);
                param = new SqlParameter("@Address", iAddress);
                command.Parameters.Add(param);
                param = new SqlParameter("@City", iCity);
                command.Parameters.Add(param);
                param = new SqlParameter("@ZipCode", iZipCode);
                command.Parameters.Add(param);
                param = new SqlParameter("@MemberType", "Deaktiveret");
                command.Parameters.Add(param);
                _sqlConnection.Open();
                Int32 memberId = (Int32)(command.ExecuteScalar());
                DeleteVerificationCode(iEmail);
                AddSubscibtion(memberId);
                return true;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        private bool DeleteVerificationCode(string email)
        {
            try
            {
                String SQLQuery = "DELETE FROM VerificationCode WHERE Email = @Email";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Email", email);
                command.Parameters.Add(param);
                //_sqlConnection.Open();
                command.ExecuteNonQuery();
                return true;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
        }

        public bool AddSubscibtion(int memberId)
        {
            try
            {
                String SQLQuery = "INSERT INTO Subscibtion VALUES(@MemberId, null)";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@MemberId", memberId);
                command.Parameters.Add(param);
                command.ExecuteNonQuery();
                return true;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
        }
        public bool VerificationCode(string iEmail, string verificationCode)
        {
            try
            {
                String SQLQuery = "INSERT INTO VerificationCode VALUES(@Email, @Code)";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Email", iEmail);
                command.Parameters.Add(param);
                param = new SqlParameter("@Code", verificationCode);
                command.Parameters.Add(param);
                _sqlConnection.Open();
                command.ExecuteNonQuery();
                return true;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        public bool CheckVerificationCode(string iEmail, string iVerificationCode)
        {
            try
            {
                String SQLQuery = "SELECT COUNT(*) FROM VerificationCode WHERE Email = @Email AND Code = @Code";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@Email", iEmail);
                command.Parameters.Add(param);
                param = new SqlParameter("@Code", iVerificationCode);
                command.Parameters.Add(param);
                _sqlConnection.Open();
                Int32 length = (Int32)command.ExecuteScalar();
                if (length > 0)
                {
                    return true;
                }

                return false;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        public bool isEmailUsed(string email)
        {
            try
            {
                _sqlConnection.Open();
                string SQLQuery = "SELECT COUNT(Email) FROM Member WHERE Email = @email";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@email", email);
                command.Parameters.Add(param);
                Int32 length = (Int32)command.ExecuteScalar();
                if (length > 0)
                {
                    return true;
                }
                return false;
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }

        public string GetCity(string zipCode)
        {
            try
            {
                string SQLQuery = "SELECT City FROM City WHERE ZipCode = @zipCode";
                SqlCommand command = new SqlCommand(SQLQuery, _sqlConnection);
                SqlParameter param = new SqlParameter("@zipCode", zipCode);
                command.Parameters.Add(param);
                _sqlConnection.Open();
                SqlDataReader dr = command.ExecuteReader();
                while (dr.Read())
                {
                    return dr["City"].ToString();
                }
                return "City not found";
            }
            catch (SqlException sqlEx)
            {
                throw new Exception(sqlEx.Message);
            }
            finally
            {
                _sqlConnection.Close();
            }
        }
    }
}