﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SignUp
{
    public partial class _Default : Page
    {
        static DAO _dao = DAO.Instance;

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                string error = Request.QueryString["error"];
                if (error == "input")
                {
                    warningLabel.Visible = true;
                    warningLabel.InnerText = "Alle felter skal være udfyldt";
                }
                if (error == "warning")
                {
                    warningLabel.Visible = true;
                    warningLabel.InnerText = "Du blev nægtet adgang";
                }
            }
            catch (Exception ex)
            {
                warningLabel.Visible = true;
                warningLabel.InnerText = ex.Message;
            }
        }


        private void SendVerificationCode(string to, string verificationCode)
        {
            try
            {
                _dao.VerificationCode(to, verificationCode);
            }
            catch (Exception)
            {
                Response.Write("Database problems");
            }
            MailMessage mail = new MailMessage("admin@k19svenner.onmicrosoft.com", to);
            SmtpClient client = new SmtpClient
            {
                Port = 587,
                EnableSsl = true,
                DeliveryMethod = SmtpDeliveryMethod.Network,
                UseDefaultCredentials = false,
                Credentials = new NetworkCredential("admin@k19svenner.onmicrosoft.com", "Vaqu1823"),
                Host = "smtp.office365.com"
            };
            mail.Subject = "Bekræftelseskode til K19s Venner";
            mail.Body = " Kopier og indtast koden på hjemmesiden for at gennemføre din oprettelse: " + verificationCode;
            client.Send(mail);
        }

        public static string RandomStr()
        {
            string rStr = Path.GetRandomFileName();
            rStr = rStr.Replace(".", ""); // For Removing the .
            rStr = rStr.Remove(10);
            return rStr;
        }

        protected void ButtonSend_Click(object sender, EventArgs e)
        {
            String iEmail = Email.Text;
            string verificationCode = RandomStr();

            String iName = Name.Text;
            String iBirthday = Birthday.Text;
            String iPhone = Phone.Text;
            String iZipCode = ZipCode.Text;
            String iAddress = Address.Text;
            String iCity = City2.Text;

            bool isEmpty = CheckIfEmpty(iName, iBirthday, iPhone, iZipCode, iAddress, iCity, iEmail);
            if (!isEmpty)
            {
                if (_dao.isEmailUsed(iEmail))
                {
                    Response.Write("Email er allerede i brug");
                }
                else
                {
                    SendVerificationCode(iEmail, verificationCode);
                    Response.Redirect("Verify.aspx?name=" + iName + "&SendVerificationCode=" + iEmail + "&birthday=" + iBirthday +
                                      "&phone=" + iPhone + "&zipCode=" + iZipCode + "&address=" + iAddress + "&city=" +
                                      iCity);
                }
            }
        }

        private bool CheckIfEmpty(string iName, string iBirthday, string iPhone, string iZipCode, string iAddress, string iCity, string iEmail)
        {
            int emptyBox = 0;
            if (String.IsNullOrEmpty(iName))
            {
//                -webkit-box-shadow: 0px 0px 10px 1px rgba(245,22,22,1);
//-moz-box-shadow: 0px 0px 10px 1px rgba(245,22,22,1);
//box-shadow: 0px 0px 10px 1px rgba(245,22,22,1);
                emptyBox++;
                string cssClass = Name.Attributes["class"];
                cssClass += " emptyTextBox";
                Name.Attributes["class"] = cssClass;
            }
            DateTime datevalue;
            if (String.IsNullOrEmpty(iBirthday) || !DateTime.TryParse(iBirthday, out datevalue))
            {
                emptyBox++;
                string cssClass = Email.Attributes["class"];
                cssClass += " emptyTextBox";
                Birthday.Attributes["class"] = cssClass;

            }
            if (String.IsNullOrEmpty(iPhone))
            {
                emptyBox++;
                string cssClass = Phone.Attributes["class"];
                cssClass += " emptyTextBox";
                Phone.Attributes["class"] = cssClass;
            }
            if (String.IsNullOrEmpty(iZipCode))
            {
                emptyBox++;
                string cssClass = ZipCode.Attributes["class"];
                cssClass += " emptyTextBox";
                ZipCode.Attributes["class"] = cssClass;

            }
            if (String.IsNullOrEmpty(iAddress))
            {
                emptyBox++;
                string cssClass = Address.Attributes["class"];
                cssClass += " emptyTextBox";
                Address.Attributes["class"] = cssClass;

            }
            if (String.IsNullOrEmpty(iCity))
            {
                emptyBox++;
                string cssClass = City.Attributes["class"];
                cssClass += " emptyTextBox";
                City.Attributes["class"] = cssClass;
            }
            if (String.IsNullOrEmpty(iEmail))
            {
                emptyBox++;
                string cssClass = Email.Attributes["class"];
                cssClass += " emptyTextBox";
                Email.Attributes["class"] = cssClass;
            }
            if (emptyBox > 0)
            {
                warningLabel.Visible = true;
                warningLabel.InnerText = "Alle felter skal være udfyldt";
                return true;
            }
            return false;
        }

        [WebMethod]
        public static string ZipCode_OnTextChanged(string zipCode)
        {
            string city = _dao.GetCity(zipCode);
            return city.TrimEnd();
        }
    }
}