﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SignUp
{
    public partial class Verify : System.Web.UI.Page
    {
        DAO _dao = DAO.Instance;
        protected void Page_PreRender(object sender, EventArgs e)
        {
            if (Request.QueryString.Count < 7)
            {
                Response.Redirect("Default.aspx?error=" + "warning");
            }
            else
            {
                foreach (string qstring in Request.QueryString)
                {
                    if (qstring.Length < 1)
                    {
                        Response.Redirect("Default.aspx?error=" + "input");
                    }
                }
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {

            String name = Request.QueryString["name"];
            String email = Request.QueryString["SendVerificationCode"];
            String birthday = Request.QueryString["birthday"];
            String phone = Request.QueryString["phone"];
            String address = Request.QueryString["address"];
            String zipCode = Request.QueryString["zipCode"];
            String city = Request.QueryString["city"];

            Name.Text = name;
            Email.Text = email;
            Birthday.Text = birthday;
            Phone.Text = phone;
            Address.Text = address;
            ZipCode.Text = zipCode;
            City.Text = city;
            VerificationCode.Focus();
        }

        protected void Submit_Click(object sender, EventArgs e)
        {
            String iEmail = Email.Text;
            String iVerificationCode = VerificationCode.Text;
            if (_dao.CheckVerificationCode(iEmail, iVerificationCode))
            {
                String iName = Name.Text;
                String iBirthday = Birthday.Text;
                String iPhone = Phone.Text;
                String iZipCode = ZipCode.Text;
                String iAddress = Address.Text;
                String iCity = City.Text;
                try
                {
                    if (_dao.SignUp(iName, iEmail, iBirthday, iPhone, iAddress, iCity, iZipCode))
                    {
                        SendWelcomeEmail(iEmail);
                        Response.Redirect("Confirm.aspx?name=" + iName);
                    }
                    else
                    {
                        Response.Write("Der er sket en fejl i oprettelsen. Prøv at oprette dig igen eller kontakt admin@k19svenner.onmicrosoft.com");
                    }
                }
                catch (Exception ex)
                {
                    Response.Write(ex.Message);
                }
                
            }
            else
            {
                Response.Write("Ikke fundet");
            }
        }

        private void SendWelcomeEmail(string toEmail)
        {
            MailMessage mail = new MailMessage("admin@k19svenner.onmicrosoft.com", toEmail);
            SmtpClient client = new SmtpClient
            {
                Port = 587,
                EnableSsl = true,
                DeliveryMethod = SmtpDeliveryMethod.Network,
                UseDefaultCredentials = false,
                Credentials = new NetworkCredential("admin@k19svenner.onmicrosoft.com", "Vaqu1823"),
                Host = "smtp.office365.com"
            };
            mail.Subject = "Velkommen til K19s venner";
            mail.Body = "Du blev oprettet i systemet. \n\n Når bestyrelsen har modtaget din ansøgning, vil der blive sendt en faktura. Når beløbet er blevet betalt, vil du få adgang til medlemssystemet.";
            client.Send(mail);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Cancel_Click(object sender, EventArgs e)
        {
            Response.Redirect("Default.aspx");
        }
    }
}